#include "MainWindow.h"
#include "ui_MainWindow.h"

#include <QtGui>
#include <QtDebug>

#include <QGraphicsItem>

class Line : public QGraphicsItem
{
    using QGraphicsItem::QGraphicsItem;

    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
    QWidget *widget) override
    {
        QPen line_pen(QPen(QBrush(QColor(255,255,0)),1,Qt::DashLine));
        double x1 = INFINITY;
        qreal x2 = 24;
        qreal x3 = 34;
        qreal x4 = 44;
        painter->setPen(line_pen);
        qDebug() << "paint was call";
        painter->drawLine(x1, x2, x3, x4);
    }

    QRectF boundingRect() const override{return {0,0, 44, 44};}

};

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    scene.setSceneRect(-300, -300, 600, 600);
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_button_clicked()
{
    auto line = new Line;
    line->setPos({3,3});
    scene.addItem(new Line());
    ui->graphicsView->setScene(&scene);
}
